Index: stylesheets/xhtml/lfs-index.xsl
===================================================================
--- stylesheets/xhtml/lfs-index.xsl	(revision 2ec64b313286681a709807dff868a30250f31207)
+++ stylesheets/xhtml/lfs-index.xsl	(revision 2ec64b313286681a709807dff868a30250f31207)
@@ -0,0 +1,188 @@
+<?xml version='1.0' encoding='ISO-8859-1'?>
+<!DOCTYPE xsl:stylesheet [
+<!ENTITY lowercase "'abcdefghijklmnopqrstuvwxyz'">
+<!ENTITY uppercase "'ABCDEFGHIJKLMNOPQRSTUVWXYZ'">
+<!ENTITY primary   'normalize-space(concat(primary/@sortas, primary[not(@sortas)]))'>
+<!ENTITY scope 'count(ancestor::node()|$scope) = count(ancestor::node())'>
+]>
+
+<!-- Version 0.9 - Manuel Canales Esparcia <macana@lfs-es.org> -->
+
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+                xmlns="http://www.w3.org/1999/xhtml"
+                version="1.0">
+
+    <!--Filename-->
+  <xsl:template match="index" mode="recursive-chunk-filename">
+    <xsl:text>longindex.html</xsl:text>
+  </xsl:template>
+
+    <!--Title-->
+  <xsl:param name="index-title">Index of packages and important installed files</xsl:param>
+  
+  <xsl:template match="index" mode="title.markup">
+    <xsl:value-of select="$index-title"/>
+	</xsl:template>
+  
+  <xsl:template name="index.titlepage">
+    <div class="titlepage">
+    	<h1 class="index">
+    		<xsl:value-of select="$index-title"/>
+			</h1>
+    </div>
+  </xsl:template>
+
+  	<!--Divisions-->
+  <xsl:template match="indexterm" mode="index-div">
+    <xsl:param name="scope" select="."/>
+    <xsl:variable name="key" select="translate(substring(&primary;, 1, 1),&lowercase;,&uppercase;)"/>
+    <xsl:variable name="divtitle" select="translate($key, &lowercase;, &uppercase;)"/>
+    	<!-- Make sure that we don't generate a div if there are no terms in scope -->
+    <xsl:if test="key('letter', $key)[&scope;] [count(.|key('primary', &primary;)[&scope;][1]) = 1]">
+      <div class="indexdiv">
+        <xsl:if test="contains(concat(&lowercase;, &uppercase;), $key)">
+          <h2>
+          	<xsl:choose>
+            	<xsl:when test="$divtitle = 'A'">
+              	<xsl:text>Packages</xsl:text>
+             </xsl:when>
+             <xsl:when test="$divtitle = 'B'">
+              	<xsl:text>Programs</xsl:text>
+             </xsl:when>
+             <xsl:when test="$divtitle = 'C'">
+              	<xsl:text>Libraries</xsl:text>
+             </xsl:when>
+             <xsl:when test="$divtitle = 'D'">
+              	<xsl:text>Scripts</xsl:text>
+             </xsl:when>
+              <xsl:when test="$divtitle = 'E'">
+                  <xsl:text>Others</xsl:text>
+              </xsl:when>
+             <xsl:otherwise>
+          		<xsl:value-of select="$divtitle"/>
+						</xsl:otherwise>
+           </xsl:choose>
+          </h2>
+        </xsl:if>
+        <ul>
+          <xsl:apply-templates select="key('letter', $key)[&scope;]
+          				[count(.|key('primary', &primary;)[&scope;][1])=1]" mode="index-primary">
+            <xsl:with-param name="scope" select="$scope"/>
+            <xsl:sort select="translate(&primary;, &lowercase;, &uppercase;)"/>
+          </xsl:apply-templates>
+        </ul>
+      </div>
+    </xsl:if>
+  </xsl:template>
+
+  	<!-- Dropping the separator from here-->
+  <xsl:template match="indexterm" mode="reference">
+    <xsl:param name="scope" select="."/>
+      <xsl:call-template name="reference">
+        <xsl:with-param name="zones" select="normalize-space(@zone)"/>
+        <xsl:with-param name="scope" select="$scope"/>
+      </xsl:call-template>
+	</xsl:template>
+
+  	<!-- Changing the output tags and re-addind the separator-->
+  <xsl:template match="indexterm" mode="index-primary">
+    <xsl:param name="scope" select="."/>
+    <xsl:variable name="key" select="&primary;"/>
+    <xsl:variable name="refs" select="key('primary', $key)[&scope;]"/>
+    <li>
+    	<strong class="item">
+      	<xsl:value-of select="primary"/>
+        <xsl:text>: </xsl:text>
+			</strong>
+      <xsl:for-each select="$refs[generate-id() = generate-id(key('primary-section',
+      				concat($key, &#34; &#34;, generate-id((ancestor-or-self::book |ancestor-or-self::part
+              |ancestor-or-self::chapter |ancestor-or-self::appendix |ancestor-or-self::preface
+              |ancestor-or-self::sect1 |ancestor-or-self::sect2 |ancestor-or-self::sect3
+              |ancestor-or-self::sect4 |ancestor-or-self::sect5 |ancestor-or-self::index)[last()])))[&scope;][1])]">
+        <xsl:apply-templates select="." mode="reference">
+          <xsl:with-param name="scope" select="$scope"/>
+        </xsl:apply-templates>
+      </xsl:for-each>
+    	<xsl:if test="$refs/secondary">
+        <ul>
+          <xsl:apply-templates select="$refs[secondary and count(.|key('secondary', 
+          				concat($key, &#34; &#34;, normalize-space(concat(secondary/@sortas,
+                  secondary[not(@sortas)]))))[&scope;][1]) = 1]" mode="index-secondary">
+            <xsl:with-param name="scope" select="$scope"/>
+            <xsl:sort select="translate(normalize-space(concat(secondary/@sortas, 
+            				secondary[not(@sortas)])), &lowercase;, &uppercase;)"/>
+          </xsl:apply-templates>
+     		</ul>
+    	</xsl:if>
+    </li>
+  </xsl:template>
+
+  <xsl:template match="indexterm" mode="index-secondary">
+    <xsl:param name="scope" select="."/>
+    <xsl:variable name="key" select="concat(&primary;, &#34; &#34;,
+    				normalize-space(concat(secondary/@sortas, secondary[not(@sortas)])))"/>
+    <xsl:variable name="refs" select="key('secondary', $key)[&scope;]"/>
+    <li>
+    	<strong class="secitem">
+      	<xsl:value-of select="secondary"/>
+        <xsl:text>: </xsl:text>
+			</strong>
+      <xsl:for-each select="$refs[generate-id() = generate-id(key('secondary-section',
+      				concat($key, &#34; &#34;, generate-id((ancestor-or-self::book |ancestor-or-self::part
+              |ancestor-or-self::chapter |ancestor-or-self::appendix |ancestor-or-self::preface
+              |ancestor-or-self::sect1 |ancestor-or-self::sect2 |ancestor-or-self::sect3
+              |ancestor-or-self::sect4 |ancestor-or-self::sect5 |ancestor-or-self::index)[last()])))[&scope;][1])]">
+        <xsl:apply-templates select="." mode="reference">
+          <xsl:with-param name="scope" select="$scope"/>
+        </xsl:apply-templates>
+      </xsl:for-each>
+    </li>
+  </xsl:template>
+
+    <!--Links (This template also fix a bug in the original code)-->
+  <xsl:template name="reference">
+    <xsl:param name="scope" select="."/>
+    <xsl:param name="zones"/>
+    <xsl:choose>
+      <xsl:when test="contains($zones, ' ')">
+        <xsl:variable name="zone" select="substring-before($zones, ' ')"/>
+        <xsl:variable name="zone2" select="substring-after($zones, ' ')"/>
+        <xsl:variable name="target" select="key('sections', $zone)[&scope;]"/>
+        <xsl:variable name="target2" select="key('sections', $zone2)[&scope;]"/>
+        <a>
+          <xsl:attribute name="href">
+            <xsl:call-template name="href.target.uri">
+              <xsl:with-param name="object" select="$target[1]"/>
+            </xsl:call-template>
+          </xsl:attribute>
+          <xsl:apply-templates select="$target[1]" mode="index-title-content"/>
+        </a>
+        <xsl:text> -- </xsl:text>
+        <a>
+          <xsl:attribute name="href">
+            <xsl:call-template name="href.target.uri">
+              <xsl:with-param name="object" select="$target2[1]"/>
+            </xsl:call-template>
+          </xsl:attribute>
+          <xsl:text>description</xsl:text>
+        </a>
+      </xsl:when>
+      <xsl:otherwise>
+        <xsl:variable name="zone" select="$zones"/>
+        <xsl:variable name="target" select="key('sections', $zone)[&scope;]"/>
+        <a>
+          <xsl:attribute name="href">
+            <xsl:call-template name="href.target.uri">
+              <xsl:with-param name="object" select="$target[1]"/>
+            </xsl:call-template>
+          </xsl:attribute>
+          <xsl:apply-templates select="$target[1]" mode="index-title-content"/>
+        </a>
+      </xsl:otherwise>
+    </xsl:choose>
+  </xsl:template>
+  
+    <!-- Dropping unneeded anchors -->
+  <xsl:template match="indexterm"/>
+
+</xsl:stylesheet>
Index: stylesheets/xhtml/lfs-legalnotice.xsl
===================================================================
--- stylesheets/xhtml/lfs-legalnotice.xsl	(revision 2ec64b313286681a709807dff868a30250f31207)
+++ stylesheets/xhtml/lfs-legalnotice.xsl	(revision 2ec64b313286681a709807dff868a30250f31207)
@@ -0,0 +1,76 @@
+<?xml version='1.0' encoding='ISO-8859-1'?>
+
+<!-- Version 0.9 - Manuel Canales Esparcia <macana@lfs-es.org> -->
+
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+                xmlns="http://www.w3.org/1999/xhtml"
+                version="1.0">
+
+  	<!-- Generating the page -->
+  <xsl:template match="legalnotice" mode="titlepage.mode">
+    <xsl:variable name="id"><xsl:call-template name="object.id"/></xsl:variable>
+      <xsl:variable name="filename" select="concat($base.dir, 'prologue/legalnotice.html')"/>
+    <xsl:variable name="title">
+      <xsl:apply-templates select="." mode="title.markup"/>
+    </xsl:variable>
+    <xsl:call-template name="write.chunk">
+      <xsl:with-param name="filename" select="$filename"/>
+      <xsl:with-param name="quiet" select="$chunk.quietly"/>
+      <xsl:with-param name="content">
+        <html>
+          <head>
+            <xsl:call-template name="system.head.content"/>
+            <xsl:call-template name="head.content"/>
+            <xsl:call-template name="user.head.content"/>
+          </head>
+          <body>
+            <xsl:call-template name="body.attributes"/>
+            <div class="{local-name(.)}">
+              <xsl:apply-templates mode="titlepage.mode"/>
+            </div>
+            <hr/>
+            <div class="navfooter">
+              <ul class="footerlinks">
+                <li>
+                  <a accesskey="h">
+                    <xsl:attribute name="href">
+                      <xsl:text>../index.html</xsl:text>
+                    </xsl:attribute>
+                    <xsl:text>Home</xsl:text>
+                  </a>
+                </li>
+              </ul>
+            </div>
+          </body>
+        </html>
+      </xsl:with-param>
+    </xsl:call-template>
+  </xsl:template>
+
+    <!-- Making the link-->
+  <xsl:template match="copyright" mode="titlepage.mode">
+    <p class="{name(.)}">
+      <a>
+        <xsl:attribute name="href">
+          <xsl:value-of select="'prologue/legalnotice.html'"/>
+        </xsl:attribute>
+        <xsl:call-template name="gentext">
+          <xsl:with-param name="key" select="'Copyright'"/>
+        </xsl:call-template>
+      </a>
+      <xsl:call-template name="gentext.space"/>
+      <xsl:call-template name="dingbat">
+        <xsl:with-param name="dingbat">copyright</xsl:with-param>
+      </xsl:call-template>
+      <xsl:call-template name="gentext.space"/>
+      <xsl:call-template name="copyright.years">
+        <xsl:with-param name="years" select="year"/>
+        <xsl:with-param name="print.ranges" select="$make.year.ranges"/>
+        <xsl:with-param name="single.year.ranges" select="$make.single.year.ranges"/>
+      </xsl:call-template>
+      <xsl:call-template name="gentext.space"/>
+      <xsl:apply-templates select="holder" mode="titlepage.mode"/>
+    </p>
+  </xsl:template>
+
+</xsl:stylesheet>
Index: stylesheets/xhtml/lfs-mixed.xsl
===================================================================
--- stylesheets/xhtml/lfs-mixed.xsl	(revision 2ec64b313286681a709807dff868a30250f31207)
+++ stylesheets/xhtml/lfs-mixed.xsl	(revision 2ec64b313286681a709807dff868a30250f31207)
@@ -0,0 +1,39 @@
+<?xml version='1.0' encoding='ISO-8859-1'?>
+
+<!-- Version 0.9 - Manuel Canales Esparcia <macana@lfs-es.org> -->
+
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+                xmlns="http://www.w3.org/1999/xhtml"
+                version="1.0">
+
+  <xsl:template match="screen">
+    <xsl:choose>
+    		<!-- Temporally hack -->
+      <xsl:when test="child::* = userinput">
+        <pre class="{name(.)}">
+          <kbd class="command">
+            <xsl:value-of select="."/>
+          </kbd>
+        </pre>
+      </xsl:when>
+      <!-- This should be fixed in the XML code -->
+      <!--
+      <xsl:when test="contains(text() , 'SBU')">
+        <p class="sbu">
+          <tt>
+            <xsl:value-of select="substring-before(text() , 'R')"/>
+            <br/>
+            <xsl:value-of select="substring-after(text() , 'U')"/>
+          </tt>
+        </p>
+      </xsl:when>
+      -->
+      <xsl:otherwise>
+        <pre class="{name(.)}">
+          <xsl:apply-templates/>
+        </pre>
+      </xsl:otherwise>
+    </xsl:choose>
+  </xsl:template>
+
+</xsl:stylesheet>
Index: stylesheets/xhtml/lfs-navigational.xsl
===================================================================
--- stylesheets/xhtml/lfs-navigational.xsl	(revision 2ec64b313286681a709807dff868a30250f31207)
+++ stylesheets/xhtml/lfs-navigational.xsl	(revision 2ec64b313286681a709807dff868a30250f31207)
@@ -0,0 +1,98 @@
+<?xml version='1.0' encoding='ISO-8859-1'?>
+
+<!-- Version 0.9 - Manuel Canales Esparcia <macana@lfs-es.org> -->
+
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+                xmlns="http://www.w3.org/1999/xhtml"
+                version="1.0">
+
+    <!-- Dropping the HEAD links -->
+  <xsl:template name="html.head">
+    <head>
+      <xsl:call-template name="system.head.content"/>
+      <xsl:call-template name="head.content"/>
+      <xsl:call-template name="user.head.content"/>
+    </head>
+  </xsl:template>
+
+  	<!-- Header Navigation-->
+  <xsl:template name="header.navigation">
+    <xsl:param name="prev" select="/foo"/>
+    <xsl:param name="next" select="/foo"/>
+    <xsl:param name="nav.context"/>
+    <xsl:variable name="home" select="/*[1]"/>
+    <xsl:variable name="up" select="parent::*"/>
+    <xsl:variable name="row" select="count($prev) &gt; 0 or (count($up) &gt; 0
+            and generate-id($up) != generate-id($home)) or count($next) &gt; 0"/>
+    <xsl:if test="$row and $home != .">
+      <div class="navheader">
+				<xsl:if test="$home != .">
+					<table width="100%" summary="Navigation header">
+						<tr>
+							<th colspan="3" align="center">
+								<h4>
+									<xsl:apply-templates select="$home" mode="object.title.markup"/>
+									<xsl:text> - </xsl:text>
+                  <xsl:apply-templates select="$home" mode="object.subtitle.markup"/>
+								</h4>
+							</th>
+						</tr>
+						<xsl:if test="$up != $home">
+							<tr>
+								<th colspan="3" align="center">
+									<h3>
+										<xsl:apply-templates select="$up" mode="object.title.markup"/>
+									</h3>
+								</th>
+							</tr>
+						</xsl:if>
+						<tr>
+							<td width="33%" align="left">
+								<a accesskey="p">
+									<xsl:attribute name="href">
+										<xsl:call-template name="href.target">
+											<xsl:with-param name="object" select="$prev"/>
+										</xsl:call-template>
+									</xsl:attribute>
+									<xsl:call-template name="navig.content">
+										<xsl:with-param name="direction" select="'prev'"/>
+									</xsl:call-template>
+								</a>
+								<xsl:text>&#160;</xsl:text>
+							</td>
+							<td width="34%" align="center">
+								<a accesskey="h">
+                	<xsl:attribute name="href">
+										<xsl:call-template name="href.target">
+											<xsl:with-param name="object" select="$home"/>
+										</xsl:call-template>
+									</xsl:attribute>
+									<xsl:call-template name="navig.content">
+										<xsl:with-param name="direction" select="'home'"/>
+									</xsl:call-template>
+								</a>
+							</td>
+							<td width="33%" align="right">
+								<xsl:text>&#160;</xsl:text>
+								<xsl:if test="count($next)&gt;0">
+									<a accesskey="n">
+										<xsl:attribute name="href">
+											<xsl:call-template name="href.target">
+												<xsl:with-param name="object" select="$next"/>
+											</xsl:call-template>
+										</xsl:attribute>
+										<xsl:call-template name="navig.content">
+											<xsl:with-param name="direction" select="'next'"/>
+										</xsl:call-template>
+									</a>
+								</xsl:if>
+							</td>
+						</tr>
+					</table>
+					<hr/>
+				</xsl:if>
+			</div>
+		</xsl:if>
+	</xsl:template>
+
+</xsl:stylesheet>
Index: stylesheets/xhtml/lfs-titles.xsl
===================================================================
--- stylesheets/xhtml/lfs-titles.xsl	(revision 2ec64b313286681a709807dff868a30250f31207)
+++ stylesheets/xhtml/lfs-titles.xsl	(revision 2ec64b313286681a709807dff868a30250f31207)
@@ -0,0 +1,80 @@
+<?xml version='1.0' encoding='ISO-8859-1'?>
+
+<!-- Version 0.9- Manuel Canales Esparcia <macana@lfs-es.org> -->
+
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+                xmlns="http://www.w3.org/1999/xhtml"
+                version="1.0">
+
+  <xsl:template name="part.titlepage">
+    <div class="titlepage">
+      <h1 class="{name(.)}">
+        <xsl:value-of select="title"/>
+      </h1>
+    </div>
+  </xsl:template>
+
+  <xsl:template name="chapter.titlepage">
+    <div class="titlepage">
+      <h1 class="{name(.)}">
+        <xsl:value-of select="title"/>
+      </h1>
+    </div>
+  </xsl:template>
+
+  <xsl:template name="preface.titlepage">
+    <div class="titlepage">
+      <h1 class="{name(.)}">
+        <xsl:value-of select="title"/>
+      </h1>
+    </div>
+  </xsl:template>
+
+  <xsl:template name="sect1.titlepage">
+    <xsl:choose>
+    		<!-- I should find a better test -->
+      <xsl:when test="position() = 4">
+        <div class="titlepage">
+          <xsl:if test="@id">
+            <a id="{@id}" name="{@id}"/>
+          </xsl:if>
+          <h2 class="{name(.)}">
+            <xsl:value-of select="title"/>
+          </h2>
+        </div>
+      </xsl:when>
+      <xsl:otherwise>
+        <div class="titlepage">
+          <h1 class="{name(.)}">
+            <xsl:value-of select="title"/>
+          </h1>
+        </div>
+      </xsl:otherwise>
+    </xsl:choose>
+  </xsl:template>
+
+  <xsl:template name="sect2.titlepage">
+    <xsl:choose>
+      <xsl:when test="string-length(title) = 0"/>
+      <xsl:otherwise>
+        <div class="titlepage">
+          <xsl:if test="@id">
+            <a id="{@id}" name="{@id}"/>
+          </xsl:if>
+          <h3 class="{name(.)}">
+            <xsl:value-of select="title"/>
+          </h3>
+        </div>
+      </xsl:otherwise>
+    </xsl:choose>
+  </xsl:template>
+
+  <xsl:template name="dedication.titlepage">
+    <div class="titlepage">
+      <h2 class="{name(.)}">
+        <xsl:value-of select="title"/>
+      </h2>
+    </div>
+  </xsl:template>
+
+</xsl:stylesheet>
Index: stylesheets/xhtml/lfs-toc.xsl
===================================================================
--- stylesheets/xhtml/lfs-toc.xsl	(revision 2ec64b313286681a709807dff868a30250f31207)
+++ stylesheets/xhtml/lfs-toc.xsl	(revision 2ec64b313286681a709807dff868a30250f31207)
@@ -0,0 +1,144 @@
+<?xml version='1.0' encoding='ISO-8859-1'?>
+
+<!-- Version 0.9 - Manuel Canales Esparcia <macana@lfs-es.org> -->
+
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+                xmlns="http://www.w3.org/1999/xhtml"
+                version="1.0">
+                
+		<!-- General settings -->
+  <xsl:param name="generate.toc">
+    appendix  toc
+    book      toc,title,figure,table,example,equation
+    chapter   nop
+    part      toc
+    preface   nop
+    qandadiv  nop
+    qandaset  nop
+    reference nop
+    sect1     nop
+    sect2     nop
+    sect3     nop
+    sect4     nop
+    sect5     nop
+    section   nop
+    set       nop
+  </xsl:param>
+
+  <xsl:param name="toc.section.depth">1</xsl:param>
+
+  <xsl:param name="toc.max.depth">3</xsl:param>
+  
+  	<!-- Making the TOC -->
+	<xsl:template name="make.toc">
+    <xsl:param name="toc-context" select="."/>
+    <xsl:param name="nodes" select="/NOT-AN-ELEMENT"/>
+    <xsl:if test="$nodes">
+      <div class="toc">
+        <h3>
+          <xsl:call-template name="gentext">
+            <xsl:with-param name="key">TableofContents</xsl:with-param>
+          </xsl:call-template>
+        </h3>
+        <ul>
+          <xsl:apply-templates select="$nodes" mode="toc">
+            <xsl:with-param name="toc-context" select="$toc-context"/>
+          </xsl:apply-templates>
+        </ul>
+      </div>
+    </xsl:if>
+  </xsl:template>
+	
+    <!-- Making the subtocs -->
+  <xsl:template name="subtoc">
+    <xsl:param name="toc-context" select="."/>
+    <xsl:param name="nodes" select="NOT-AN-ELEMENT"/>
+    <xsl:variable name="subtoc">
+      <ul>
+        <xsl:apply-templates mode="toc" select="$nodes">
+          <xsl:with-param name="toc-context" select="$toc-context"/>
+        </xsl:apply-templates>
+      </ul>
+    </xsl:variable>
+    <xsl:variable name="depth">
+      <xsl:choose>
+        <xsl:when test="local-name(.) = 'sect1'">1</xsl:when>
+        <xsl:otherwise>0</xsl:otherwise>
+      </xsl:choose>
+    </xsl:variable>
+    <xsl:variable name="depth.from.context"
+            select="count(ancestor::*)-count($toc-context/ancestor::*)"/>
+    <li class="{name(.)}">
+      <xsl:call-template name="toc.line">
+        <xsl:with-param name="toc-context" select="$toc-context"/>
+      </xsl:call-template>
+      <xsl:if test="$toc.section.depth &gt; $depth and count($nodes)&gt;0 
+      				and $toc.max.depth &gt; $depth.from.context">
+        <xsl:copy-of select="$subtoc"/>
+      </xsl:if>
+    </li>
+  </xsl:template>
+
+    <!--Adding the h* tags and dropping redundats links-->
+  <xsl:template name="toc.line">
+    <xsl:param name="toc-context" select="."/>
+    <xsl:param name="depth" select="1"/>
+    <xsl:param name="depth.from.context" select="8"/>
+    <xsl:choose>
+      <xsl:when test="local-name(.) = 'sect1'">
+        <a>
+          <xsl:attribute name="href">
+            <xsl:call-template name="href.target">
+              <xsl:with-param name="context" select="$toc-context"/>
+            </xsl:call-template>
+          </xsl:attribute>
+          <xsl:apply-templates select="." mode="titleabbrev.markup"/>
+        </a>
+      </xsl:when>
+      <xsl:when test="local-name(.) = 'chapter' or local-name(.) = 'preface'">
+        <h4>
+          <xsl:variable name="label">
+            <xsl:apply-templates select="." mode="label.markup"/>
+          </xsl:variable>
+          <xsl:copy-of select="$label"/>
+          <xsl:if test="$label != ''">
+            <xsl:value-of select="$autotoc.label.separator"/>
+          </xsl:if>
+          <xsl:apply-templates select="." mode="titleabbrev.markup"/>
+        </h4>
+      </xsl:when>
+      <xsl:when test="local-name(.) = 'part'">
+        <h3>
+          <xsl:variable name="label">
+            <xsl:apply-templates select="." mode="label.markup"/>
+          </xsl:variable>
+          <xsl:copy-of select="$label"/>
+          <xsl:if test="$label != ''">
+            <xsl:value-of select="$autotoc.label.separator"/>
+          </xsl:if>
+          <xsl:apply-templates select="." mode="titleabbrev.markup"/>
+        </h3>
+      </xsl:when>
+      <xsl:otherwise>
+        <h3>
+            <a>
+            <xsl:attribute name="href">
+              <xsl:call-template name="href.target">
+                <xsl:with-param name="context" select="$toc-context"/>
+              </xsl:call-template>
+            </xsl:attribute>
+            <xsl:variable name="label">
+              <xsl:apply-templates select="." mode="label.markup"/>
+            </xsl:variable>
+            <xsl:copy-of select="$label"/>
+            <xsl:if test="$label != ''">
+              <xsl:value-of select="$autotoc.label.separator"/>
+            </xsl:if>
+            <xsl:apply-templates select="." mode="titleabbrev.markup"/>
+          </a>
+        </h3>
+      </xsl:otherwise>
+    </xsl:choose>
+  </xsl:template>
+
+</xsl:stylesheet>
Index: tidy.conf
===================================================================
--- tidy.conf	(revision 2ec64b313286681a709807dff868a30250f31207)
+++ tidy.conf	(revision 2ec64b313286681a709807dff868a30250f31207)
@@ -0,0 +1,17 @@
+indent-spaces: 2
+wrap: 78
+tab-size: 8
+input-encoding: latin1
+output-encoding: latin1
+newline: CRLF
+write-back: yes
+markup: yes
+indent: yes
+hide-endtags: no
+uppercase-tags: no
+logical-emphasis: no
+drop-font-tags: no
+tidy-mark: no
+numeric-entities: no
+show-warnings: no
+quiet: yes
